import {system, world, Vector} from "@minecraft/server"

const prefix = "+"

// This code is made by AzunixMC2673 Discord: Zunix#7450.
// Please respect my work by not modifying or copying my code.
// Thanks for those who help me to create this addon
// CREDITS : .-- ☆ AZUNIXMC2673 ☆ --.


// Help Message 
const helpmsg = `
§6SetHome§f:
- §6Command: §7+set <name>\n
- §6Usage: §7+set <name>\n
- §6Description: §7Creates a new home with the given name.\n
- §6Example: §7+set myhouse\n
- §6Result: §7Creates a new home named "myhouse".\n
§6TeleportoHome§f:
- §6Command: §7+home <name>\n
- §6Usage: §7+home <name>\n
- §6Description: §7Teleports the player to their home with the given name.\n
- §6Example: §7+home myhouse\n
- §6Result: §7Teleports the player to the home named "myhouse".\n
§6DeleteHome§f:
- §6Command: §7delhome <name>\n
- §6Usage: §7delhome <name>\n
- §6Description: §7Deletes the home with the given name.\n
- §6Example: §7delhome myhouse\n
- §6Result: §7Deletes the home named "myhouse".
`;

// To stop Watchdog Termination
system.events.beforeWatchdogTerminate.subscribe(eventData => eventData.cancel = true);

// CREDITS: REMEMBER M9
// Debugger, use: what({variable or function})
globalThis.what = async function (data, n = 3) {
   if (data instanceof Error) {
      const { message, stack } = data
      return console.warn(message, stack)
   }
   n ? data = JSON.stringify(data, 0, n) : null
   world.sendMessage(data)
}



world.events.beforeChat.subscribe((eventData) => {
  const player = eventData.sender;
  if (!eventData.message.startsWith(prefix)) return
  switch (eventData.message.replace(prefix, "").split(" ")[0]) {
    case 'set':
      eventData.cancel = true;
      setHome(eventData);
      break;
    case 'home':
      eventData.cancel = true;
      home(eventData);
      break;
    case 'help':
      eventData.cancel = true;
      player.sendMessage(helpmsg)
      break;
    case 'delhome':
      eventData.cancel = true;
      delhome(eventData)
      break;
    default: break;
  }
});